"""
  Copyright 2012-2013 Grégory Soutadé

  This file is part of Dynastie.

  Dynastie is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dynastie is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dynastie.  If not, see <http://www.gnu.org/licenses/>.
"""

class TreeNode():

    def __init__(self, key, value):
        self.childs = []
        self.key = key
        self.value = value

    def addChildNode(self, node):
        self.childs.append(node)

    def hasChilds(self):
        return (len(self.childs) > 0)

    def find(self, key):
        if key == self.key: return self
        for child in self.childs:
            r = child.find(key)
            if r != None: return r
        return None
